---
title: Learning Web Development
tags:
- webdevelopment
- learning
- html
- css
category:
- programming
- webdev
gallery:
- url: https://roadmap.sh/frontend
  image_path: https://roadmap.sh/roadmaps/frontend.png
  alt: frontend roadmap
  title: Frontend Roadmap
- url: https://roadmap.sh/backend
  image_path: https://roadmap.sh/roadmaps/backend.png
  alt: Backend Roadmap
  title: Backend Roadmap
- url: https://roadmap.sh/devops
  image_path: https://roadmap.sh/roadmaps/devops.png
  alt: DevOps Roadmap
  title: DevOps Roadmap
date: 2020-04-21 00:44:00 +01:00
---
I mentioned in the [goals post]({% post_url "goals" %}), one of the things I am aiming to do is to start learning web development.

I was well aware that what falls under the banner of web development is massive, I just hadn't realised quite how large it was.

Thankfully there is a website called [Roadmap.sh](https://roadmap.sh) which provides handy images detailing all that you COULD learn if you had a ridiculous amount of time available, as well as some resource lists. Images are marked with the creators personal recommendations of what to learn, and also alternative options.

{% include gallery caption="Click on the images to go to the Roadmap page." %}

To be fair it isn't the only site out there that provides a list of topics to learn, but its certainly a nice visual guide that could be printed.

What I find overwhelming is what to use for learning in terms of tutorials, videos and/or courses. There is a (not literal) metric ton of free and paid content out there to take you from knowing nothing to producing websites. Too much to my mind :) just because it leaves you wondering what the best source to use is.

At the moment my focus is split between the following multiple sources

Text:

- [FreeCodeCamp](https://www.freecodecamp.org)
- [HTML Dog](https://htmldog.com/guides/)
- and a couple of others (links are on my iPad, will update later)

Video:
- [The Complete 2020 Web Development Bootcamp](https://www.udemy.com/course/the-complete-web-development-bootcamp/) by Angela Yu
- [CS50’s Web Programming with Python and JavaScript](https://cs50.harvard.edu/web/) (via [edx](https://www.edx.org/course/cs50s-web-programming-with-python-and-javascript)) - (although this is kinda a mix of both video and text)
- [Colt's Code Camp (Learn Coding From Scratch)](https://www.youtube.com/watch?v=SF_Xl5TOGlY&list=PLblA84xge2_xNtaFnZhefjFbnDrpySKD3) by Colt Steele

I'm trying to get a feel for what works best for me, what sits in my mind more and who's style I prefer the most. I kinda need at least 2 sources, because I need something I can work with that doesn't require watching a video (because say I'm sitting in a room with others)

Right now I'm still vetting, I def like Angela's course, or at least her voice, style, and humour (even if I'm watching the videos at 1.5-2.0x speed). However it is the only thing I've linked to that requires payment.

I really like FreeCodeCamp's site, and the mechanics of teaching in the browser. I seriously question the 300 hours it suggests per module. I'm virtually finished the first module within about 6 hours. I'm currently working on the first "assignment", and I could easily see spending a bunch of time doing those and making them look great.
